/*========================================================================================================
                                                   corand.h
==========================================================================================================

 Routines for the generation of correlated pseudo-random numbers
 
 C++-code accompanying: 
 
        authors : Boris H. Kramer, G. Sander van Doorn, Babak M. S. Arani, Ido Pen
        title : Eusociality and the evolution of aging in superorganisms
 

 Written by:
        G. Sander van Doorn
        Groningen Institute for Evolutionary Life Sciences (Gelifes)
        University of Groningen
        the Netherlands
 
 Program version
        01/03/2019	
 
 =====================================================================================================*/

#ifndef corand_h
#define corand_h

#include "random.h"
#include "linalg.h"

namespace rnd
{
    class MultiNormal
    {
    public:
        MultiNormal(const Matrix&, const Vector&);
        MultiNormal(const Matrix&);
        Vector operator()() const;
        friend std::ostream& operator<< (std::ostream&, const MultiNormal&);
    private:
        const Vector::size_type n;
        const Vector mu;
        Vector sigma;
        Matrix U;
    };
}
#endif /* #ifndef corand_h */
